Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# AsyncTaskManager Class Reference

A class to manage a loose queue of isolated tasks, which can be performed either synchronously (in the foreground thread) or asynchronously (by a background thread). More...

Inheritance diagram for AsyncTaskManager:

List of all members.

## Public Member Functions
| AsyncTaskManager (string name)
| add (AsyncTask task)
| Adds the indicated task to the active queue.
| cleanup ()
| Stops all threads and messily empties the task list.
AsyncTask | findTask (string name)
| Returns the first task found with the indicated name, or NULL if there is no task with the indicated name.
AsyncTaskChain | findTaskChain (string name)
| Searches a new AsyncTaskChain of the indicated name and returns it if it exists, or NULL otherwise.
AsyncTaskCollection | findTasks (string name)
| Returns the list of tasks found with the indicated name.
AsyncTaskCollection | findTasksMatching (GlobPattern const pattern)
| Returns the list of tasks found whose name matches the indicated glob pattern, e.g.
AsyncTaskCollection | getActiveTasks ()
| Returns the set of tasks that are active (and not sleeping) on the task manager, at the time of the call.
ClockObject | getClock ()
| Returns the clock pointer used within the AsyncTaskManager.
double | getNextWakeTime ()
| Returns the scheduled time (on the manager's clock) of the next sleeping task, on any task chain, to awaken.
int | getNumTaskChains ()
| Returns the number of different task chains.
int | getNumTasks ()
| Returns the number of tasks that are currently active or sleeping within the task manager.
AsyncTaskCollection | getSleepingTasks ()
| Returns the set of tasks that are sleeping (and not active) on the task manager, at the time of the call.
AsyncTaskChain | getTaskChain (int n)
| Returns the nth task chain.
list | getTaskChains ()
AsyncTaskCollection | getTasks ()
| Returns the set of tasks that are active or sleeping on the task manager, at the time of the call.
bool | hasTask (AsyncTask task)
| Returns true if the indicated task has been added to this AsyncTaskManager, false otherwise.
AsyncTaskChain | makeTaskChain (string name)
| Creates a new AsyncTaskChain of the indicated name and stores it within the AsyncTaskManager.
| output (ostream out)
| Outputs the Namable.
| poll ()
| Runs through all the tasks in the task list, once, if the task manager is running in single-threaded mode (no threads available).
int | remove (AsyncTaskCollection const tasks)
| Removes all of the tasks in the AsyncTaskCollection.
bool | remove (AsyncTask task)
| Removes the indicated task from the active queue.
bool | removeTaskChain (string name)
| Removes the AsyncTaskChain of the indicated name.
| setClock (ClockObject clock)
| Replaces the clock pointer used within the AsyncTaskManager.
| startThreads ()
| Starts any requested threads to service the tasks on the queue.
| stopThreads ()
| Stops any threads that are currently running.
| waitForTasks ()
| Blocks until the task list is empty.
| write (ostream out, int indent_level)
| write (ostream out)
## Static Public Member Functions
static TypeHandle | getClassType ()
static AsyncTaskManager | getGlobalPtr ()
| Returns a pointer to the global AsyncTaskManager.

## Detailed Description

A class to manage a loose queue of isolated tasks, which can be performed either synchronously (in the foreground thread) or asynchronously (by a background thread).

The AsyncTaskManager is actually a collection of AsyncTaskChains, each of which maintains a list of tasks. Each chain can be either foreground or background (it may run only in the main thread, or it may be serviced by one or more background threads). See AsyncTaskChain for more information.

If you do not require background processing, it is perfectly acceptable to create only one AsyncTaskChain, which runs in the main thread. This is a common configuration.

## Constructor & Destructor Documentation

AsyncTaskManager | ( | string | name | ) |

## Member Function Documentation

add | ( | AsyncTask | task | ) |

Adds the indicated task to the active queue.

It is an error if the task is already added to this or any other active queue.

cleanup | ( |  | ) |

Stops all threads and messily empties the task list.

This is intended to be called on destruction only.

AsyncTask findTask | ( | string | name | ) |

Returns the first task found with the indicated name, or NULL if there is no task with the indicated name.

If there are multiple tasks with the same name, returns one of them arbitrarily.

AsyncTaskChain findTaskChain | ( | string | name | ) |

Searches a new AsyncTaskChain of the indicated name and returns it if it exists, or NULL otherwise.

AsyncTaskCollection findTasks | ( | string | name | ) |

Returns the list of tasks found with the indicated name.

AsyncTaskCollection findTasksMatching | ( | GlobPattern const | pattern | ) |

Returns the list of tasks found whose name matches the indicated glob pattern, e.g.

"my_task_*".

AsyncTaskCollection getActiveTasks | ( |  | ) |

Returns the set of tasks that are active (and not sleeping) on the task manager, at the time of the call.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedReferenceCount.

ClockObject getClock | ( |  | ) |

Returns the clock pointer used within the AsyncTaskManager.

See set_clock().

static AsyncTaskManager getGlobalPtr | ( |  | ) | `[static]`

Returns a pointer to the global AsyncTaskManager.

This is the AsyncTaskManager that most code should use for queueing tasks and suchlike.

double getNextWakeTime | ( |  | ) |

Returns the scheduled time (on the manager's clock) of the next sleeping task, on any task chain, to awaken.

Returns -1 if there are no sleeping tasks.

int getNumTaskChains | ( |  | ) |

Returns the number of different task chains.

int getNumTasks | ( |  | ) |

Returns the number of tasks that are currently active or sleeping within the task manager.

AsyncTaskCollection getSleepingTasks | ( |  | ) |

Returns the set of tasks that are sleeping (and not active) on the task manager, at the time of the call.

AsyncTaskChain getTaskChain | ( | int | n | ) |

Returns the nth task chain.

list getTaskChains | ( |  | ) |

AsyncTaskCollection getTasks | ( |  | ) |

Returns the set of tasks that are active or sleeping on the task manager, at the time of the call.

bool hasTask | ( | AsyncTask | task | ) |

Returns true if the indicated task has been added to this AsyncTaskManager, false otherwise.

AsyncTaskChain makeTaskChain | ( | string | name | ) |

Creates a new AsyncTaskChain of the indicated name and stores it within the AsyncTaskManager.

If a task chain with this name already exists, returns it instead.

output | ( | ostream | out | ) |

Outputs the Namable.

This function simply writes the name to the output stream; most Namable derivatives will probably redefine this.

Reimplemented from Namable.

poll | ( |  | ) |

Runs through all the tasks in the task list, once, if the task manager is running in single-threaded mode (no threads available).

This method does nothing in threaded mode, so it may safely be called in either case.

bool remove | ( | AsyncTask | task | ) |

Removes the indicated task from the active queue.

Returns true if the task is successfully removed, or false if it wasn't there.

int remove | ( | AsyncTaskCollection const | tasks | ) |

Removes all of the tasks in the AsyncTaskCollection.

Returns the number of tasks removed.

bool removeTaskChain | ( | string | name | ) |

Removes the AsyncTaskChain of the indicated name.

If the chain still has tasks, this will block until all tasks are finished.

Returns true if successful, or false if the chain did not exist.

setClock | ( | ClockObject | clock | ) |

Replaces the clock pointer used within the AsyncTaskManager.

This is used to control when tasks with a set_delay() specified will be scheduled. It can also be ticked automatically each epoch, if set_tick_clock() is true.

The default is the global clock pointer.

startThreads | ( |  | ) |

Starts any requested threads to service the tasks on the queue.

This is normally not necessary, since adding a task will start the threads automatically.

stopThreads | ( |  | ) |

Stops any threads that are currently running.

If any tasks are still pending and have not yet been picked up by a thread, they will not be serviced unless poll() or start_threads() is later called.

waitForTasks | ( |  | ) |

Blocks until the task list is empty.

write | ( | ostream | out | ) |

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

All Classes Namespaces Functions Variables Enumerations Enumerator Properties